searchNodes=[{"ref":"Swiss.html","title":"Swiss","type":"module","doc":"Swiss Swiss is a bundle of extensions to the standard lib. It includes several helper functions for dealing with standard types. API The root module has generic helper functions; check each sub-module&#39;s docs for each type&#39;s API."},{"ref":"Swiss.html#nextable/1","title":"Swiss.nextable/1","type":"function","doc":"Wrapper that makes any function usable directly in Kernel.get_in/2. Examples iex&gt; get_in([%{&quot;life&quot; =&gt; 42}], [Swiss.nextable(&amp;List.first/1), &quot;life&quot;]) 42"},{"ref":"Swiss.html#tap/2","title":"Swiss.tap/2","type":"function","doc":"Applies the given func to value and returns value. Examples iex&gt; Swiss.tap(42, &amp;(12 + &amp;1)) 42"},{"ref":"Swiss.html#thru/2","title":"Swiss.thru/2","type":"function","doc":"Applies the given func to value and returns its result. Examples iex&gt; Swiss.thru(42, &amp;(12 + &amp;1)) 54"},{"ref":"Swiss.DateTime.html","title":"Swiss.DateTime","type":"module","doc":"Some extra functions for working with DateTimes that aren&#39;t in the native lib or on Timex."},{"ref":"Swiss.DateTime.html#from_iso8601!/2","title":"Swiss.DateTime.from_iso8601!/2","type":"function","doc":"Converts a ISO 8601 date into a DateTime and offset. This is a wrapper around DateTime.from_iso8601/2 that raises on error. Examples iex&gt; Swiss.DateTime.from_iso8601!(&quot;2015-01-23T23:50:07Z&quot;) {~U[2015-01-23 23:50:07Z], 0}"},{"ref":"Swiss.DateTime.html#max/1","title":"Swiss.DateTime.max/1","type":"function","doc":"Returns the biggest (latest) of the given list of dates. Examples iex&gt; Swiss.DateTime.max([DateTime.from_unix!(1_577_664_000), DateTime.from_unix!(2_464_096_360), DateTime.from_unix!(1_464_096_368)]) ~U[2048-01-31 15:12:40Z] iex&gt; Swiss.DateTime.max([DateTime.from_unix!(2_464_096_360), nil]) ~U[2048-01-31 15:12:40Z]"},{"ref":"Swiss.DateTime.html#max/2","title":"Swiss.DateTime.max/2","type":"function","doc":"Returns the biggest (latest) of two dates. Examples iex&gt; Swiss.DateTime.max(DateTime.from_unix!(1_577_664_000), DateTime.from_unix!(1_464_096_368)) ~U[2019-12-30 00:00:00Z]"},{"ref":"Swiss.DateTime.html#min/1","title":"Swiss.DateTime.min/1","type":"function","doc":"Returns the smallest (earliest) of the given list of dates. Examples iex&gt; Swiss.DateTime.min([DateTime.from_unix!(1_577_664_000), DateTime.from_unix!(2_464_096_360), DateTime.from_unix!(1_464_096_368)]) ~U[2016-05-24 13:26:08Z] iex&gt; Swiss.DateTime.min([DateTime.from_unix!(2_464_096_360), nil]) ~U[2048-01-31 15:12:40Z]"},{"ref":"Swiss.DateTime.html#min/2","title":"Swiss.DateTime.min/2","type":"function","doc":"Returns the smallest (earliest) of two dates. Examples iex&gt; Swiss.DateTime.min(DateTime.from_unix!(1_577_664_000), DateTime.from_unix!(1_464_096_368)) ~U[2016-05-24 13:26:08Z]"},{"ref":"Swiss.DateTime.html#second_utc_now/0","title":"Swiss.DateTime.second_utc_now/0","type":"function","doc":"Helper method for getting &quot;now&quot; with second precision."},{"ref":"Swiss.Enum.html","title":"Swiss.Enum","type":"module","doc":"Helper functions for dealing with Enumerables."},{"ref":"Swiss.Enum.html#find_both/2","title":"Swiss.Enum.find_both/2","type":"function","doc":"Finds an element and its index in enumerable for which fun returns true. Examples iex&gt; Swiss.Enum.find_both([42, 44, 46], fn num -&gt; num == 44 end) {44, 1} iex&gt; Swiss.Enum.find_both([42, 44, 46], fn num -&gt; num == 45 end) nil"},{"ref":"Swiss.Enum.html#find_by/4","title":"Swiss.Enum.find_by/4","type":"function","doc":"Finds the first element in enumerable where its key equals value. Returns default if not found. Examples iex&gt; Swiss.Enum.find_by([%{life: 11}, %{life: 42}], :life, 42) %{life: 42} iex&gt; Swiss.Enum.find_by([%{life: 11}, %{life: 42}], :wat, 42) nil iex&gt; Swiss.Enum.find_by([%{life: 11}, %{life: 42}], 42, :wat, 42) 42 iex&gt; Swiss.Enum.find_by([%Swiss.TestStruct{life: 42}], :life, 42) %Swiss.TestStruct{life: 42}"},{"ref":"Swiss.Enum.html#find_by!/3","title":"Swiss.Enum.find_by!/3","type":"function","doc":"Finds the first element in enumerable where its key equals value. Raises if not found. Examples iex&gt; Swiss.Enum.find_by!([%{life: 11}, %{life: 42}], :life, 42) %{life: 42} iex&gt; Swiss.Enum.find_by!([%{life: 11}, %{life: 42}], :wat, 42) ** (Swiss.Enum.KeyValueError) key :wat with value 42 not found in: [%{life: 11}, %{life: 42}]"},{"ref":"Swiss.Enum.html#group_by_single/3","title":"Swiss.Enum.group_by_single/3","type":"function","doc":"Same as Enum.group_by/3 but expects each group to have a single element, and therefore returns only that element per key, instead of a list. Examples iex&gt; Swiss.Enum.group_by_single( ...&gt; [%{k: &quot;life&quot;, v: 42}, %{k: &quot;death&quot;, v: 13}, %{k: &quot;ooo&quot;, v: 0}], ...&gt; &amp; &amp;1.k, ...&gt; &amp; &amp;1.v ...&gt; ) %{&quot;life&quot; =&gt; 42, &quot;death&quot; =&gt; 13, &quot;ooo&quot; =&gt; 0}"},{"ref":"Swiss.Enum.html#thru/2","title":"Swiss.Enum.thru/2","type":"function","doc":"Applies cb to all elements in enum, ignores the return and returns enum. Examples iex&gt; Swiss.Enum.thru([1, 2, 3], fn a -&gt; a + 1 end) [1, 2, 3]"},{"ref":"Swiss.Enum.KeyValueError.html","title":"Swiss.Enum.KeyValueError","type":"exception","doc":""},{"ref":"Swiss.Enum.KeyValueError.html#message/3","title":"Swiss.Enum.KeyValueError.message/3","type":"function","doc":""},{"ref":"Swiss.Map.html","title":"Swiss.Map","type":"module","doc":"A few extra functions to deal with Maps."},{"ref":"Swiss.Map.html#from_struct/1","title":"Swiss.Map.from_struct/1","type":"function","doc":"Wrapper around Map.from_struct/1 that tolerates nil. Examples iex&gt; Swiss.Map.from_struct(nil) nil iex&gt; Swiss.Map.from_struct(%{__struct__: SomeStruct, life: 42}) %{life: 42}"},{"ref":"Swiss.Map.html#indif_fetch!/2","title":"Swiss.Map.indif_fetch!/2","type":"function","doc":"Fetches a value from a map with indifferent access, i.e. given an atom, returns the value that is keyed by that atom, or by its string equivalent. If both atom and String keys exist in the map, the atom&#39;s value is returned. Examples iex&gt; Swiss.Map.indif_fetch!(%{life: 42}, :life) 42 iex&gt; Swiss.Map.indif_fetch!(%{&quot;life&quot; =&gt; 42}, :life) 42 iex&gt; Swiss.Map.indif_fetch!(%{:life =&gt; 42, &quot;life&quot; =&gt; 64}, :life) 42 iex&gt; Swiss.Map.indif_fetch!(%{}, :life) ** (KeyError) key :life not found in: %{}"},{"ref":"Swiss.Map.html#to_string_keys/1","title":"Swiss.Map.to_string_keys/1","type":"function","doc":"Converts an atom-keyed map into a string-keyed map. Examples iex&gt; Swiss.Map.to_string_keys(%{life: 42}) %{&quot;life&quot; =&gt; 42} iex&gt; Swiss.Map.to_string_keys(%{&quot;life&quot; =&gt; 42, death: 27}) %{&quot;life&quot; =&gt; 42, &quot;death&quot; =&gt; 27}"},{"ref":"Swiss.String.html","title":"Swiss.String","type":"module","doc":"A few extra functions to deal with Strings. Heavily inspired by lodash."},{"ref":"Swiss.String.html#deburr/1","title":"Swiss.String.deburr/1","type":"function","doc":"Deburrs a string from unicode to its ascii equivalent. Examples iex&gt; Swiss.String.deburr &quot;hola señor!&quot; &quot;hola senor!&quot;"},{"ref":"Swiss.String.html#kebab_case/1","title":"Swiss.String.kebab_case/1","type":"function","doc":"Converts a string into kebab-case. Examples iex&gt; Swiss.String.kebab_case &quot;Foo Bar&quot; &quot;foo-bar&quot; iex&gt; Swiss.String.kebab_case &quot;--foo-bar--&quot; &quot;foo-bar&quot; iex&gt; Swiss.String.kebab_case &quot;__FOO_BAR__&quot; &quot;foo-bar&quot; iex&gt; Swiss.String.kebab_case &quot;FooBar&quot; &quot;foo-bar&quot;"},{"ref":"Swiss.String.html#snake_case/1","title":"Swiss.String.snake_case/1","type":"function","doc":"Converts a string into snake_case. Examples iex&gt; Swiss.String.snake_case &quot;Foo Bar&quot; &quot;foo_bar&quot; iex&gt; Swiss.String.snake_case &quot;--foo-bar--&quot; &quot;foo_bar&quot; iex&gt; Swiss.String.snake_case &quot;__FOO_BAR__&quot; &quot;foo_bar&quot;"},{"ref":"Swiss.String.html#words/2","title":"Swiss.String.words/2","type":"function","doc":"Decomposes a string into an array of its words. Examples iex&gt; Swiss.String.words &quot;FredBarney&quot; [&quot;Fred&quot;, &quot;Barney&quot;] iex&gt; Swiss.String.words &quot;fred, barney, &amp; pebbles&quot; [&quot;fred&quot;, &quot;barney&quot;, &quot;pebbles&quot;] iex&gt; Swiss.String.words &quot;fred, barney, &amp; pebbles&quot;, ~r/[^, ]+/ [&quot;fred&quot;, &quot;barney&quot;, &quot;&amp;&quot;, &quot;pebbles&quot;]"},{"ref":"Swiss.Struct.html","title":"Swiss.Struct","type":"module","doc":"A few extra fuctions to work with Structs."},{"ref":"Swiss.Struct.html#to_params_map/1","title":"Swiss.Struct.to_params_map/1","type":"function","doc":"Converts a struct into a string-key map (eg: params from post). Examples iex&gt; Swiss.Struct.to_params_map(%Swiss.TestStruct{life: 42}) %{&quot;life&quot; =&gt; 42}"},{"ref":"Swiss.Task.html","title":"Swiss.Task","type":"module","doc":"Functions for writing async code that&#39;s testable asynchronously by passing allowances to created processes. You should import this module and use its macros as a DSL. Example defmodule YourProject.Task do @moduledoc &quot;Defines the Task API for your project&quot; import Swiss.Task async YourProject.Task.Allowances async_stream YourProject.Task.Allowances end defmodule YourProject.Task.Allowances do @moduledoc &quot;Defines the Allowances behaviour&quot; @behaviour Swiss.Task.Allowances @impl true def allow(parent) do Ecto.Adapters.SQL.Sandbox.allow(YourProject.Repo, parent, self()) end end defmodule YourProject.SomeModule do def some_async_function do YourProject.Task.async(fn -&gt; end) end def some_other_async_function(enumerable) do YourProject.Task.async_stream(enumerable, fn -&gt; end) end end"},{"ref":"Swiss.Task.html#async/1","title":"Swiss.Task.async/1","type":"macro","doc":"Call this macro from your projects Task module to declare an async function that, in a test environment, runs the called module&#39;s allow function with the parent process&#39;s PID. In other envs this delegates to the Elixir.Task.async/1 function."},{"ref":"Swiss.Task.html#async_stream/1","title":"Swiss.Task.async_stream/1","type":"macro","doc":"Call this macro from your project&#39;s Task module to define an async_stream function that, in a test environment, runs the called module&#39;s allow function with the parent process&#39;s PID In other envs this delegates to the Elixir.Task.async_stream/3 function."},{"ref":"Swiss.Task.Allowances.html","title":"Swiss.Task.Allowances","type":"behaviour","doc":""},{"ref":"Swiss.Task.Allowances.html#c:allow/1","title":"Swiss.Task.Allowances.allow/1","type":"callback","doc":""}]